<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: OpenSim::ModelFactory Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classOpenSim_1_1ModelFactory.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="classOpenSim_1_1ModelFactory-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">OpenSim::ModelFactory Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class provides utilities for creating <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> models.  
 <a href="classOpenSim_1_1ModelFactory.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td colspan="2"><div class="groupHeader">Create a model</div></td></tr>
<tr class="memitem:ae0ab8c472b09c8b7e28269622759049c"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#ae0ab8c472b09c8b7e28269622759049c">createNLinkPendulum</a> (int numLinks)</td></tr>
<tr class="memdesc:ae0ab8c472b09c8b7e28269622759049c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a pendulum with the provided number of links.  <a href="classOpenSim_1_1ModelFactory.html#ae0ab8c472b09c8b7e28269622759049c">More...</a><br /></td></tr>
<tr class="separator:ae0ab8c472b09c8b7e28269622759049c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a93b57057e1015819da8e84eede63adf1"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#a93b57057e1015819da8e84eede63adf1">createPendulum</a> ()</td></tr>
<tr class="memdesc:a93b57057e1015819da8e84eede63adf1"><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a convenience for <code>createNLinkPendulum(1)</code>.  <a href="classOpenSim_1_1ModelFactory.html#a93b57057e1015819da8e84eede63adf1">More...</a><br /></td></tr>
<tr class="separator:a93b57057e1015819da8e84eede63adf1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74afd44ffc8b05f48b4f1c26c9a998e8"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#a74afd44ffc8b05f48b4f1c26c9a998e8">createDoublePendulum</a> ()</td></tr>
<tr class="memdesc:a74afd44ffc8b05f48b4f1c26c9a998e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">This is a convenience for <code>createNLinkPendulum(2)</code>.  <a href="classOpenSim_1_1ModelFactory.html#a74afd44ffc8b05f48b4f1c26c9a998e8">More...</a><br /></td></tr>
<tr class="separator:a74afd44ffc8b05f48b4f1c26c9a998e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abce2780a5c35c1bc2746ce7e78c973da"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#abce2780a5c35c1bc2746ce7e78c973da">createSlidingPointMass</a> ()</td></tr>
<tr class="memdesc:abce2780a5c35c1bc2746ce7e78c973da"><td class="mdescLeft">&#160;</td><td class="mdescRight">This model contains:  <a href="classOpenSim_1_1ModelFactory.html#abce2780a5c35c1bc2746ce7e78c973da">More...</a><br /></td></tr>
<tr class="separator:abce2780a5c35c1bc2746ce7e78c973da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae218ebfe8a66c98328c28319597e7d27"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classOpenSim_1_1Model.html">Model</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#ae218ebfe8a66c98328c28319597e7d27">createPlanarPointMass</a> ()</td></tr>
<tr class="memdesc:ae218ebfe8a66c98328c28319597e7d27"><td class="mdescLeft">&#160;</td><td class="mdescRight">This model contains:  <a href="classOpenSim_1_1ModelFactory.html#ae218ebfe8a66c98328c28319597e7d27">More...</a><br /></td></tr>
<tr class="separator:ae218ebfe8a66c98328c28319597e7d27"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr><td colspan="2"><div class="groupHeader">Modify a Model</div></td></tr>
<tr class="memitem:ac4a3dac72ca61261a05727c59b2e6fe4"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#ac4a3dac72ca61261a05727c59b2e6fe4">replaceMusclesWithPathActuators</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:ac4a3dac72ca61261a05727c59b2e6fe4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Replace muscles in a model with a <a class="el" href="classOpenSim_1_1PathActuator.html" title="This is the base class for actuators that apply controllable tension along a geometry path.">PathActuator</a> of the same <a class="el" href="classOpenSim_1_1GeometryPath.html" title="A base class representing a path (muscle, ligament, etc.).">GeometryPath</a>, optimal force, and min/max control defaults.  <a href="classOpenSim_1_1ModelFactory.html#ac4a3dac72ca61261a05727c59b2e6fe4">More...</a><br /></td></tr>
<tr class="separator:ac4a3dac72ca61261a05727c59b2e6fe4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac55ff3c19d6eb99079668789b1dbb528"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#ac55ff3c19d6eb99079668789b1dbb528">removeMuscles</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model)</td></tr>
<tr class="memdesc:ac55ff3c19d6eb99079668789b1dbb528"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove muscles from the model.  <a href="classOpenSim_1_1ModelFactory.html#ac55ff3c19d6eb99079668789b1dbb528">More...</a><br /></td></tr>
<tr class="separator:ac55ff3c19d6eb99079668789b1dbb528"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d92a8c0e51328284f66ff00e570cba6"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#a6d92a8c0e51328284f66ff00e570cba6">replaceJointWithWeldJoint</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, const std::string &amp;jointName)</td></tr>
<tr class="memdesc:a6d92a8c0e51328284f66ff00e570cba6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Replace a joint in the model with a <a class="el" href="classOpenSim_1_1WeldJoint.html" title="A class implementing a Weld joint.">WeldJoint</a>.  <a href="classOpenSim_1_1ModelFactory.html#a6d92a8c0e51328284f66ff00e570cba6">More...</a><br /></td></tr>
<tr class="separator:a6d92a8c0e51328284f66ff00e570cba6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89c02bc5d9722ca220edf8b169e45e30"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOpenSim_1_1ModelFactory.html#a89c02bc5d9722ca220edf8b169e45e30">createReserveActuators</a> (<a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;model, double optimalForce, double bound=SimTK::NaN, bool skipCoordinatesWithExistingActuators=true)</td></tr>
<tr class="memdesc:a89c02bc5d9722ca220edf8b169e45e30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add <a class="el" href="classOpenSim_1_1CoordinateActuator.html" title="An actuator that applies a generalized force in the direction of a generalized coordinate.">CoordinateActuator</a>s for each unconstrained coordinate (e.g., <code>! Coordinate::isConstrained()</code>) in the model, using the provided optimal force.  <a href="classOpenSim_1_1ModelFactory.html#a89c02bc5d9722ca220edf8b169e45e30">More...</a><br /></td></tr>
<tr class="separator:a89c02bc5d9722ca220edf8b169e45e30"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description </h2>
<div class="textblock"><p>This class provides utilities for creating <a class="el" href="namespaceOpenSim.html" title="The Moco interface is contained within the OpenSim namespace.">OpenSim</a> models. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a74afd44ffc8b05f48b4f1c26c9a998e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74afd44ffc8b05f48b4f1c26c9a998e8">&#9670;&nbsp;</a></span>createDoublePendulum()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Model.html">Model</a> OpenSim::ModelFactory::createDoublePendulum </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This is a convenience for <code>createNLinkPendulum(2)</code>. </p>

</div>
</div>
<a id="ae0ab8c472b09c8b7e28269622759049c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae0ab8c472b09c8b7e28269622759049c">&#9670;&nbsp;</a></span>createNLinkPendulum()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Model.html">Model</a> OpenSim::ModelFactory::createNLinkPendulum </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>numLinks</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create a pendulum with the provided number of links. </p>
<p>For each link, there is a body <code>/bodyset/b#</code> (where <code>#</code> is the link index starting at 0), a <a class="el" href="classOpenSim_1_1PinJoint.html" title="A Class implementing a Pin joint.">PinJoint</a> <code>/jointset/j#</code> with coordinate <code>/jointset/j#/q#</code>, a <a class="el" href="classOpenSim_1_1CoordinateActuator.html" title="An actuator that applies a generalized force in the direction of a generalized coordinate.">CoordinateActuator</a> <code>/tau#</code>, a <a class="el" href="classOpenSim_1_1Marker.html" title="A class implementing a Mocap marker.">Marker</a> <code>/markerset/marker#</code> at the origin of the link's body, and a <a class="el" href="classOpenSim_1_1PhysicalOffsetFrame.html" title="A PhysicalOffsetFrame is a PhysicalFrame whose transform is specified as a constant offset from anoth...">PhysicalOffsetFrame</a> <code>/b#center</code> at the center of the link. </p>

</div>
</div>
<a id="a93b57057e1015819da8e84eede63adf1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93b57057e1015819da8e84eede63adf1">&#9670;&nbsp;</a></span>createPendulum()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Model.html">Model</a> OpenSim::ModelFactory::createPendulum </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This is a convenience for <code>createNLinkPendulum(1)</code>. </p>

</div>
</div>
<a id="ae218ebfe8a66c98328c28319597e7d27"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae218ebfe8a66c98328c28319597e7d27">&#9670;&nbsp;</a></span>createPlanarPointMass()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Model.html">Model</a> OpenSim::ModelFactory::createPlanarPointMass </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This model contains: </p>
<ul>
<li>2 bodies: a massless body "intermed", and "body" with mass 1.</li>
<li>2 slider joints: "tx" and "ty" (coordinates "tx" and "ty").</li>
<li>2 coordinate actuators: "force_x" and "force_y". Gravity is default; that is, (0, -g, 0). </li>
</ul>

</div>
</div>
<a id="a89c02bc5d9722ca220edf8b169e45e30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89c02bc5d9722ca220edf8b169e45e30">&#9670;&nbsp;</a></span>createReserveActuators()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::ModelFactory::createReserveActuators </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>optimalForce</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>bound</em> = <code>SimTK::NaN</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>skipCoordinatesWithExistingActuators</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add <a class="el" href="classOpenSim_1_1CoordinateActuator.html" title="An actuator that applies a generalized force in the direction of a generalized coordinate.">CoordinateActuator</a>s for each unconstrained coordinate (e.g., <code>! Coordinate::isConstrained()</code>) in the model, using the provided optimal force. </p>
<p>Increasing the optimal force decreases the required control signal to generate a given actuation level. The actuators are added to the model's <a class="el" href="classOpenSim_1_1ForceSet.html" title="A class for holding and managing a set of forces for a model.">ForceSet</a> and are named "reserve_&lt;coordinate-path&gt;" with forward slashes converted to underscores. The <code>bound</code> argument, if supplied, sets the min and max controls to <code>-bound</code> and <code>bound</code>, respectively. The fourth (optional) argument specifies whether or not to skip coordinates that already have <a class="el" href="classOpenSim_1_1CoordinateActuator.html" title="An actuator that applies a generalized force in the direction of a generalized coordinate.">CoordinateActuator</a>s associated with them (default: true). </p>

</div>
</div>
<a id="abce2780a5c35c1bc2746ce7e78c973da"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abce2780a5c35c1bc2746ce7e78c973da">&#9670;&nbsp;</a></span>createSlidingPointMass()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOpenSim_1_1Model.html">Model</a> OpenSim::ModelFactory::createSlidingPointMass </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This model contains: </p>
<ul>
<li>1 body: mass 1.0 kg, <code>/bodyset/body</code>.</li>
<li>1 joint: <a class="el" href="classOpenSim_1_1SliderJoint.html" title="A class implementing a Slider joint.">SliderJoint</a> along x axis, <code>/jointset/slider</code>, with coordinate <code>/jointset/slider/position</code>.</li>
<li>1 actuator: <a class="el" href="classOpenSim_1_1CoordinateActuator.html" title="An actuator that applies a generalized force in the direction of a generalized coordinate.">CoordinateActuator</a>, controls [-10, 10], <code>/actuator</code>. Gravity is default; that is, (0, -g, 0). </li>
</ul>

</div>
</div>
<a id="ac55ff3c19d6eb99079668789b1dbb528"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac55ff3c19d6eb99079668789b1dbb528">&#9670;&nbsp;</a></span>removeMuscles()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::ModelFactory::removeMuscles </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Remove muscles from the model. </p>
<dl class="section note"><dt>Note</dt><dd>This only removes muscles within the model's <a class="el" href="classOpenSim_1_1ForceSet.html" title="A class for holding and managing a set of forces for a model.">ForceSet</a>. </dd></dl>

<p class="reference">Referenced by <a class="el" href="classOpenSim_1_1ModOpRemoveMuscles.html#a0774db7df6bc053356e06126003c30c7">OpenSim::ModOpRemoveMuscles::operate()</a>.</p>

</div>
</div>
<a id="a6d92a8c0e51328284f66ff00e570cba6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d92a8c0e51328284f66ff00e570cba6">&#9670;&nbsp;</a></span>replaceJointWithWeldJoint()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::ModelFactory::replaceJointWithWeldJoint </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>jointName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Replace a joint in the model with a <a class="el" href="classOpenSim_1_1WeldJoint.html" title="A class implementing a Weld joint.">WeldJoint</a>. </p>
<dl class="section note"><dt>Note</dt><dd>This assumes the joint is in the <a class="el" href="classOpenSim_1_1JointSet.html" title="A class for holding a set of joints.">JointSet</a> and that the joint's connectees are PhysicalOffsetFrames. </dd></dl>

</div>
</div>
<a id="ac4a3dac72ca61261a05727c59b2e6fe4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac4a3dac72ca61261a05727c59b2e6fe4">&#9670;&nbsp;</a></span>replaceMusclesWithPathActuators()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void OpenSim::ModelFactory::replaceMusclesWithPathActuators </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOpenSim_1_1Model.html">Model</a> &amp;&#160;</td>
          <td class="paramname"><em>model</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Replace muscles in a model with a <a class="el" href="classOpenSim_1_1PathActuator.html" title="This is the base class for actuators that apply controllable tension along a geometry path.">PathActuator</a> of the same <a class="el" href="classOpenSim_1_1GeometryPath.html" title="A base class representing a path (muscle, ligament, etc.).">GeometryPath</a>, optimal force, and min/max control defaults. </p>
<dl class="section note"><dt>Note</dt><dd>This only replaces muscles within the model's <a class="el" href="classOpenSim_1_1ForceSet.html" title="A class for holding and managing a set of forces for a model.">ForceSet</a>. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>OpenSim/Actuators/ModelFactory.h</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceOpenSim.html">OpenSim</a></li><li class="navelem"><a class="el" href="classOpenSim_1_1ModelFactory.html">ModelFactory</a></li>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:26 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
